
/*
*******************************************************************************
	Sequence Description
*******************************************************************************
[ Slave Bluetooth Device ]

< STEP_1 >
 Bluetooth Deviceκ   ޽  ƾ
 Bluetooth Deviceκ "BTWIN Slave mode start"޽ ŵǾ ˻
  - Bluetooth Device Slave ۵ ,   STEP_4 
  - Bluetooth Deviceκ "BTWIN Master mode start"޽ ŵǾ ˻
  - Bluetooth Device Master ۵ ,   STEP_2 
  Ͱ Ʋ  errorƾ ó

< STEP_2 >
 Bluetooth Device Role  ƾ 1°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
  - Bluetooth Device "Master" ۵  "OK" ޽  , 
    "at+btrol=s\r" Command ̿Ͽ Bluetooth Device Slave 
  Ͱ Ʋ  errorƾ ó

< STEP_3 >
 Bluetooth Device Role  ƾ 2°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
  - "at+btrole=s\r" Command ̿Ͽ Bluetooth Device Slave   "OK" ޽ 
  -  Role ϱ  "atz\r" Command ̿Ͽ Bluetooth Device Soft Reset 
  -   STEP_1 
  Ͱ Ʋ  errorƾ ó

< STEP_4 >
 Bluetooth Device ˻/   ƾ 1°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
  - Bluetooth Device "Slave" ۵  OK޽  , 
    "at+btscan\r" Command ̿Ͽ Bluetooth Device ˻/  · 
  Ͱ Ʋ  errorƾ ó

< STEP_5 >
 Bluetooth Device ˻/   ƾ 2°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
   - "at+btscan\r" Command ̿Ͽ Bluetooth Device ˻/  ·   "OK"޽ 
  Ͱ Ʋ  errorƾ ó

< STEP_6 >
 Bluetooth Device   üũ ƾ
 Bluetooth Deviceκ "CONNECT"޽ ŵǾ ˻
  - Slave ˻/ ⸦ ϰ ִ , Master ˻   
  - Slave Master   "CONNECT"޽ 
  - Slave Master  ,  / ƾ 
  Ͱ Ʋ  errorƾ ó
==========================================================================
[ Master Bluetooth Device ]

< STEP_1 >
 Bluetooth Deviceκ   ޽  ƾ
 Bluetooth Deviceκ "BTWIN Slave mode start"޽ ŵǾ ˻
  - Bluetooth Device Slave ۵ ,   STEP_2 
 Bluetooth Deviceκ "BTWIN Master mode start"޽ ŵǾ ˻
  - Bluetooth Device Master ۵ ,   STEP_4 
  Ͱ Ʋ  errorƾ ó

< STEP_2 >
 Bluetooth Device Role  ƾ 1°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
  - Bluetooth Device "Slave" ۵  "OK" ޽  , "at+btrole=m\r" Command
     ̿Ͽ Bluetooth Device Master 
  -   STEP_3 
  Ͱ Ʋ  errorƾ ó

< STEP_3 >
 Bluetooth Device Role  ƾ 2°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
  - "at+btrole=m\r" Command ̿Ͽ Bluetooth Device Master   
    "OK" ޽ 
  -  Role ϱ  "atz\r" Command ̿Ͽ Bluetooth Device Soft Reset 
  -   STEP_1 
  Ͱ Ʋ  errorƾ ó

< STEP_4 >
 Bluetooth Device  û ƾ 1°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
  - Bluetooth Device "Master" ۵  "OK"޽  , "atd" Command 
    Ǿ ִ Slave 巹 ̿Ͽ  û 
  -   STEP_5 
  Ͱ Ʋ  errorƾ ó

< STEP_5 >
 Bluetooth Device  û ƾ 2°
 Bluetooth Deviceκ "OK"޽ ŵǾ ˻
  - "atd" Command Slave 巹 ̿Ͽ  û Ǵ  "OK"޽ 
  -   STEP_6 
  Ͱ Ʋ  errorƾ ó

< STEP_6 >
 Bluetooth Device   üũ ƾ
 Bluetooth Deviceκ "CONNECT"޽ ŵǾ ˻
  - Master Slave  ϱ ؼ Slave ˻/  ̾ 
  - Master Slave   "CONNECT"޽ 
  - Master Slave  ,  / ƾ (ƾ   STEP_7 )
  Ͱ Ʋ  errorƾ ó
*/

/*
*******************************************************************************
Include Part
*******************************************************************************
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include  <string.h>
#include  <stdio.h>

#include "main.h"
/*
********************************************************************************
Function For UART0
********************************************************************************
*/
SIGNAL(SIG_UART0_RECV)
{
	rx0_buf[p_rx0_wr++] = UDR0;
	if (p_rx0_wr > UART0_BUF_SIZE-1)p_rx0_wr = 0;
	//
	if(rx0_buf[p_rx0_wr-1] == LF_VALUE)lf_check_flag++;
}

void Init_UART0(unsigned char baudrate)
{
	unsigned int i;
	
	UBRR0H      = 0;
	if(baudrate == BAUD_9600){UBRR0L = 71;}/* 9600 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_19200){UBRR0L = 35;}/* 19200 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_38400){UBRR0L = 17;}/* 38400 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_57600){UBRR0L = 11;}/* 57600 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_115200){UBRR0L = 5;} /* 115200 BAUD at 11.0592MHz*/
	else {UBRR0L = 71;};/* default 9600 BAUD at 11.0592MHz*/
	UCSR0B = (1<<RXCIE)|(1<<RXEN)|(1<<TXEN);
	p_rx0_wr = 0;
	p_rx0_rd = 0;
	for (i=0; i<UART0_BUF_SIZE; i++) rx0_buf[i] = 0;
 }

unsigned char PutChar0 (unsigned char c)
{
	while (!(UCSR0A & 0x20)) ;
	UDR0 = c;
	return 0;
}

void DispStr0 (unsigned char *s)
{
	while (*s != '\0') {
		PutChar0(*s++);
	}
}

unsigned int Check_Rx_Buf0(void)
{
	unsigned int len;

	if (p_rx0_wr == p_rx0_rd) {
		len = 0;
	}
	else {
		if (p_rx0_wr > p_rx0_rd) len = p_rx0_wr - p_rx0_rd;
		else len = UART0_BUF_SIZE + p_rx0_wr - p_rx0_rd;
	}
	return len;
}

unsigned char GetChar0 (void)
{
	unsigned char ch;
    
	ch = rx0_buf[p_rx0_rd];
	p_rx0_rd++;
	if (p_rx0_rd > UART0_BUF_SIZE-1) p_rx0_rd = 0;
	return ch;
}
/*
********************************************************************************
Function For UART1
********************************************************************************
*/
SIGNAL(SIG_UART1_RECV)
{
	rx1_buf[p_rx1_wr++] = UDR1;
	if (p_rx1_wr > UART1_BUF_SIZE-1)p_rx1_wr = 0;
}

void Init_UART1(unsigned char baudrate)
{
	unsigned int i;

	UBRR1H      = 0;
	if(baudrate == BAUD_9600){UBRR1L = 71;}/* 9600 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_19200){UBRR1L = 35;}/* 19200 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_38400){UBRR1L = 17;}/* 38400 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_57600){UBRR1L = 11;}/* 57600 BAUD at 11.0592MHz*/
	else if(baudrate == BAUD_115200){UBRR1L = 5;} /* 115200 BAUD at 11.0592MHz*/
	else {UBRR1L = 71;};/* default 9600 BAUD at 11.0592MHz*/
	UCSR1B = (1<<RXCIE)|(1<<RXEN)|(1<<TXEN);
	p_rx1_wr = 0;
	p_rx1_rd = 0;
	for (i=0; i<UART1_BUF_SIZE; i++) rx1_buf[i] = 0;
}

unsigned char PutChar1 (unsigned char c)
{
	while (!(UCSR1A & 0x20)) ;
	UDR1 = c;
	return 0;
}

void DispStr1 (unsigned char *s)
{
	while (*s != '\0') {
		PutChar1(*s++);
	}
	PutChar1(0x0a);
	PutChar1(0x0d);
}

void DispStr1_line (unsigned char *s)
{
	while (*s != '\0') {
		PutChar1(*s++);
	}
}

unsigned int Check_Rx_Buf1(void)
{
	unsigned int len;

	if (p_rx1_wr == p_rx1_rd) {
		len = 0;
	}
	else {
		if (p_rx1_wr > p_rx1_rd) len = p_rx1_wr - p_rx1_rd;
		else len = UART1_BUF_SIZE + p_rx1_wr - p_rx1_rd;
	}
	return len;
}

unsigned char GetChar1 (void)
{
	unsigned char ch;
    
	ch = rx1_buf[p_rx1_rd];
	p_rx1_rd++;
	if (p_rx1_rd > UART1_BUF_SIZE-1) p_rx1_rd = 0;
	return ch;
}
/*
********************************************************************************
Function For Timer0 & LED
********************************************************************************
*/
SIGNAL(SIG_OVERFLOW0)
{

	timer0_counter++;
	if (timer0_counter > 200 )
	{	
		timer0_counter = 0;
	}
	status_led();
}

void init_timer0(void)
{

	TIMSK |= 1 << TOIE0;
	TCNT0 = 0;
	TCCR0 = 5;
	timer0_counter = 0;
}

void status_led(void)
{
	if(status_sequence == BEFORE_CONNECT)
	{
		if (timer0_counter < 100 )
		{
			if(read_avr_port == DIP_1)
				write_port_value(WRITE_LED_1_ON);
			else if(read_avr_port == DIP_2)
				write_port_value(WRITE_LED_2_ON);
		}
		else if (timer0_counter < 200  )
		{
			if(read_avr_port == DIP_1)
				write_port_value(WRITE_LED_1_OFF);
			else if(read_avr_port == DIP_2)
				write_port_value(WRITE_LED_2_OFF);
		}
	}
	else
	{
		if(read_avr_port == DIP_1)
			write_port_value(WRITE_LED_1_ON);
		else if(read_avr_port == DIP_2)
			write_port_value(WRITE_LED_2_ON);
	}
}
/*
********************************************************************************
Get Bluetooth 
Address from Device
********************************************************************************
*/
void get_bluetooth_address(void)
{
	unsigned int i;

	step_slave_bt = STEP_1;
	init_uart0_read_data();
	while(1)
	{
		uart0_length = Check_Rx_Buf0();
		if(uart0_length>0)
		{
			if(lf_check_flag == 2)
			{
				uart0_length = Check_Rx_Buf0();
				for(i = 0;i<uart0_length;i++)
					uart0_read_data[i] = GetChar0();
				//
				switch(step_slave_bt)
				{
					case STEP_1:
						lf_check_flag = LF_CHECK_NON;
						if(!memcmp("\r\nBTWIN Slave mode start\r\n",&uart0_read_data[uart0_length-26],26))
						{
							step_slave_bt++;
						}
						else if(!memcmp("\r\nBTWIN Master mode start\r\n",&uart0_read_data[uart0_length-27],27))
						{
							step_slave_bt++;
						}
						else
							execution_error();
					break;
					case STEP_2:
						lf_check_flag = LF_CHECK_NON;
						if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
						{
							step_slave_bt++;
							DispStr0("at+btinfo?8\r");
						}
						else
							execution_error();
					break;
					case STEP_3:
						lf_check_flag = LF_CHECK_NON;
						if(uart0_length == 16)
						{
							step_slave_bt++;
							DispStr1("[FB155MC_gcc V0.1]");
							DispStr1("[Bluetooth Device Address]");
							for(i = 0;i < uart0_length;i++)
								PutChar1(uart0_read_data[i]);
						}
						else
							execution_error();
					break;
				}	
				init_uart0_read_data();
				//
			}
		}
	}
}
/*
********************************************************************************
CONVERT HEX INTO CHAR
********************************************************************************
*/
unsigned char Hex2Char(unsigned char c)
{
	if (c >= 0 && c <= 9)
		return '0' + c;
	if (c >= 10 && c <= 15)
		return 'A' + c - 10;

	return c;
}

/*
********************************************************************************
Function For Delay
********************************************************************************
*/
void wait_1ms(unsigned int cnt)
{
	unsigned int i;

	for (i = 0; i < cnt; i++) wait_1us(1000);
}

void wait_1us(unsigned int cnt)
{
	unsigned int i;

	for (i = 0; i < cnt; i++) ;
}
/*
********************************************************************************
Function For Initialize PORT
********************************************************************************
*/
void init_port (void)
{
	DDRA  = 0x00;
	PORTA = 0x0f;

	DDRB  = 0xff;
	PORTB = 0xf0;
	
	DDRC  = 0x03;
	PORTC = 0x00;
	
	DDRD  = 0xff;
	PORTD = 0x00;
	
	DDRE  = 0xff;
	PORTE = 0x00;
	
	DDRF  = 0xff;
	PORTF = 0x00;
}
/*
********************************************************************************
Function For PORT Read
********************************************************************************
*/
unsigned char read_port_value(unsigned char avr_port_num)
{
	unsigned char return_avr_port_value;
	
	switch(avr_port_num)
	{
		case READ_DIP:
			return_avr_port_value = PINA;
			return_avr_port_value = return_avr_port_value & 0xf0;
			break;
		case READ_SWITCH:
			return_avr_port_value = PINA;
			return_avr_port_value = return_avr_port_value & 0x0f;
			break;
		default:
			break;
	}
	return return_avr_port_value;
}
/*
********************************************************************************
Function For PORT Write
********************************************************************************
*/
void write_port_value(unsigned char avr_port_value)
{

	switch(avr_port_value)
	{
		case WRITE_LED_1_ON:
			cbi(PORTB,PB4);
			break;
		case WRITE_LED_1_OFF:
			sbi(PORTB,PB4);
			break;
		case WRITE_LED_2_ON:
			cbi(PORTB,PB5);
			break;
		case WRITE_LED_2_OFF:
			sbi(PORTB,PB5);
			break;
		default:
			break;
	}
}
/*
********************************************************************************
* Function For Init uart0_read_data
********************************************************************************
*/
void init_uart0_read_data(void)
{
	unsigned int i;
	
	for(i = 0;i<50;i++)
		uart0_read_data[i] = 0;
}
/*
********************************************************************************
* Function For error
********************************************************************************
*/
void execution_error(void)
{
	unsigned int i;
	
	DispStr1_line("[ERROR ");
	DispStr1_line(" STEP : ");
	if(read_avr_port == DIP_1)
		PutChar1(Hex2Char(step_slave_bt));
	else if(read_avr_port == DIP_2)
		PutChar1(Hex2Char(step_master_bt));
	DispStr1_line(" UART_LEN : ");
	PutChar1(Hex2Char(uart0_length));
	DispStr1_line(" DATA : ");
	for(i = 0;i < uart0_length;i++)
		PutChar1(uart0_read_data[i]);
	if(read_avr_port == DIP_1)
		step_slave_bt = 50;
	else if(read_avr_port == DIP_2)
		step_master_bt = 50;
	
}
/*
********************************************************************************
* Function For Slave Mode
********************************************************************************
*/
void compare_slave_command(void)
{
	switch(step_slave_bt)
	{
		case STEP_1:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nBTWIN Slave mode start\r\n",&uart0_read_data[uart0_length-26],26))
			{
				step_slave_bt = STEP_4;
				DispStr1("[STEP_1 : MESSAGE RECEIVE OK]");
			}
			else if(!memcmp("\r\nBTWIN Master mode start\r\n",&uart0_read_data[uart0_length-27],27))
			{
				step_slave_bt++;
				DispStr1("[STEP_1 : MESSAGE RECEIVE OK]");
			}
			else
				execution_error();
		break;
		case STEP_2:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_slave_bt++;
				DispStr1("[STEP_2 : MESSAGE RECEIVE OK]");
				DispStr1("[         CHANGE ROLE]");				
				DispStr0("at+btrole=s\r");
			}
			else
				execution_error();
		break;
		case STEP_3:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_slave_bt = STEP_1;
				DispStr1("[STEP_3 : MESSAGE RECEIVE OK]");
				DispStr1("[         RESET BLUETOOTH]");
				DispStr0("atz\r");
			}
			else
				execution_error();
		break;
		case STEP_4:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_slave_bt++;
				DispStr1("[STEP_4 : MESSAGE RECEIVE OK]");
				DispStr1("[         EXECUTON SCAN]");
				wait_1ms(100);
				DispStr0("at+btscan\r");
			}
			else
				execution_error();
		break;
		case STEP_5:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_slave_bt++;
				DispStr1("[STEP_5 : MESSAGE RECEIVE OK]");
			}
			else
				execution_error();
		break;
		case STEP_6:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nCONNECT",uart0_read_data,9))
			{
				step_master_bt++;
				status_sequence = AFTER_CONNECT;
				DispStr1("[STEP_6 : COMMUNICATION START]");
			}
			else
				execution_error();
		break;
	}	
	init_uart0_read_data();
}

void execution_slave(void)
{
	unsigned int i;

	status_sequence = BEFORE_CONNECT;
	step_slave_bt = STEP_1;
	init_uart0_read_data();
	while(1)
	{
		if(status_sequence == BEFORE_CONNECT)
		{
			uart0_length = Check_Rx_Buf0();
			if(uart0_length>0)
			{
				if(lf_check_flag == 2)
				{
					uart0_length = Check_Rx_Buf0();
					for(i = 0;i<uart0_length;i++)
						uart0_read_data[i] = GetChar0();
					compare_slave_command();
				}
			}
		}
		else if(status_sequence == AFTER_CONNECT)
		{
			lf_check_flag = LF_CHECK_NON;
			uart0_length = Check_Rx_Buf0();
			if(uart0_length)
			{
				for(i = 0;i < uart0_length;i++)
					PutChar1(GetChar0());
			}
			uart1_length = Check_Rx_Buf1();
			if(uart1_length)
			{
				for(i = 0;i < uart1_length;i++)
					PutChar0(GetChar1());
			}
		}
	}
}
/*
********************************************************************************
* Function For Master Mode
********************************************************************************
*/
void compare_master_command(void)
{
	unsigned int i;

	switch(step_master_bt)
	{
		case STEP_1:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nBTWIN Slave mode start\r\n",&uart0_read_data[uart0_length-26],26))
			{
				step_master_bt++;
				DispStr1("[STEP_1 : MESSAGE RECEIVE OK]");
			}
			else if(!memcmp("\r\nBTWIN Master mode start\r\n",&uart0_read_data[uart0_length-27],27))
			{
				step_master_bt = STEP_4;
				DispStr1("[STEP_1 : MESSAGE RECEIVE OK]");
			}
			else
				execution_error();
		break;
		case STEP_2:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_master_bt++;
				DispStr1("[STEP_2 : MESSAGE RECEIVE OK]");
				DispStr1("[         CHANGE ROLE]");				
				DispStr0("at+btrole=m\r");
			}
			else
				execution_error();
		break;
		case STEP_3:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_master_bt = STEP_1;
				DispStr1("[STEP_3 : MESSAGE RECEIVE OK]");
				DispStr1("[         RESET BLUETOOTH]");				
				DispStr0("atz\r");
			}
			else
				execution_error();
		break;
		case STEP_4:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_master_bt++;
				status_target = TARGET_DETECT;
				DispStr1("[STEP_4 : MESSAGE RECEIVE OK]");
				DispStr1("[         TRY TO CONNECT]");
				DispStr0("atd");
				for(i = 0;i<12;i++)
					PutChar0(target_data[i]);
				PutChar0(0x0d);
			}
			else
				execution_error();
		break;
		case STEP_5:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nOK\r\n",&uart0_read_data[uart0_length-6],6))
			{
				step_master_bt++;
				DispStr1("[STEP_5 : MESSAGE RECEIVE OK]");
			}
			else
				execution_error();
		break;
		case STEP_6:
			lf_check_flag = LF_CHECK_NON;
			if(!memcmp("\r\nCONNECT",&uart0_read_data[0],9))
			{
				step_master_bt++;
				status_sequence = AFTER_CONNECT;
				DispStr1("[STEP_6 : COMMUNICATION START]");
			}
			else
				execution_error();
		break;
	}
	init_uart0_read_data();
}

void execution_master(void)
{
	unsigned int i;

	//
	memcpy(target_data,"00066e150c68",12);
	//
	status_sequence = BEFORE_CONNECT;
	step_master_bt = STEP_1;
	init_uart0_read_data();
	while(1)
	{
		if(status_sequence == BEFORE_CONNECT)
		{
			uart0_length = Check_Rx_Buf0();
			if(uart0_length>0)
			{
				if(lf_check_flag == 2)
				{
					uart0_length = Check_Rx_Buf0();
					for(i = 0;i<uart0_length;i++)
						uart0_read_data[i] = GetChar0();
					compare_master_command();
				}
			}
		}
		else if(status_sequence == AFTER_CONNECT)
		{
			lf_check_flag = LF_CHECK_NON;
			uart0_length = Check_Rx_Buf0();
			if(uart0_length)
			{
				for(i = 0;i < uart0_length;i++)
					PutChar1(GetChar0());
			}
			uart1_length = Check_Rx_Buf1();
			if(uart1_length)
			{
				for(i = 0;i < uart1_length;i++)
					PutChar0(GetChar1());
			}
		}
	}
}
/*
********************************************************************************
* main Start
********************************************************************************
*/
int main(void)
{
	
	init_port();
	Init_UART1(BAUD_9600);
	Init_UART0(BAUD_9600);
	init_timer0();
	sei();

	read_avr_port = 0;
	lf_check_flag = LF_CHECK_NON;
	status_target = TARGET_NOT_DETECT;
	wait_1ms(10);
	DispStr1("\r\n\r\nFBD155MC_gcc  START");
	while(1)
	{
		read_avr_port = read_port_value(READ_DIP);
		if(read_avr_port == DIP_1)
			execution_slave();
		else if(read_avr_port == DIP_2)
			execution_master();
		else if(read_avr_port > 0x70 && read_avr_port <= 0xf0)
			get_bluetooth_address();
	}
}
/*
**************************************************************************************************************
* main End
**************************************************************************************************************
*/

